
const project = (object, filter) => {
  let projection = {}
  if (Array.isArray(filter)) {
    if (Array.isArray(object)) {
      return object.map( element => project(element, filter) )
    } else {
      for (const property of filter) {
        projection[property] = object[property]
      }
    }
  } else if (typeof filter == 'object') {
    for (const property of Object.keys(filter)) {
      projection[property] = project(object[property], filter[property])
    }
  }
  return projection
}

module.exports = { project }


